#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <fcntl.h>

#ifndef LINUX
#include <machine/cpufunc.h>
#else
#include <unistd.h>
#include <asm/io.h>
#endif

#include "methods.h"
static int iofl;

static int OpenIO()
{

#ifndef LINUX
  if((iofl=open("/dev/io",000))<0){
    return -1;
  }
#else
  ioperm(WBIO1,4,1);
  ioperm(WBIO2,4,1);
#endif

  return 0;
}
static int CloseIO()
{

#ifndef LINUX
  close(iofl);
#else
  ioperm(WBIO1,4,0);
  ioperm(WBIO2,4,0);
#endif

}
static WriteByte(int addr,int value)
{
#ifndef LINUX
  outb(WBIO1,addr);
  outb(WBIO2,value);
#else
  outb(addr, WBIO1);
  outb(value,WBIO2);
#endif
}

static int ReadByte(int addr)
{

#ifndef LINUX
  outb(WBIO1,addr);
#else
  outb(addr,WBIO1);
#endif

  return inb(WBIO2);
}

static int ReadTemp1()
{
	int n;
	WriteByte(0x4E,0x01); /* changing to bank 1 */
	n = ReadByte(0x50) + ((ReadByte(0x51) & 0xFF) << 8);
	WriteByte(0x4E,0);	/* returning to bank 0 */
	return n;
}

static int ReadTemp2()
{
	int n;
	WriteByte(0x4E,0x02); /* changing to bank 2 */
	n = ReadByte(0x50) + ((ReadByte(0x51) & 0xFF) << 8);
	WriteByte(0x4E,0);	/* returning to bank 0 */
	return n;
}

struct lm_methods method_isa={
  OpenIO,CloseIO,ReadByte,WriteByte,ReadTemp1,ReadTemp2
};
  
